// ProgErr.h - ProgramError macro

//////////// ProgramError //////////
void Program_error(char *cond, 
                   char *message, 
                   char *file, 
                   int line);

/////// The ProgramError Macro //////
// The ProgramError macro works the same 
// as the assert macro except it gives the 
// user the option of not terminating the 
// program.
// It also allows the programmer to pass a 
// message to be displayed to the user.
//
// Like assert, if NDEBUG is defined then 
// ProgramError is removed from the code.
//
#ifndef NDEBUG 
#  define ProgramError(p, message) \
   ((p) ? (void)0 : (void) \
   Program_error(#p, message, __FILE__, __LINE__ ))
#else
#  define ProgramError(p, message)
#endif

